# mpi4py.MPI.Topocomm

class mpi4py.MPI.Topocomm

  Bases: `Intracomm`

  Topology intracommunicator.

  static __new__(cls, comm=None)
    Parameters:

      comm (Topocomm | None)

    Return type:

      Self

  Methods Summary

  `Ineighbor_allgather`(sendbuf, recvbuf) | Nonblocking Neighbor Gather to All.
  `Ineighbor_allgatherv`(sendbuf, recvbuf) | Nonblocking Neighbor Gather to All Vector.
  `Ineighbor_alltoall`(sendbuf, recvbuf) | Nonblocking Neighbor All to All.
  `Ineighbor_alltoallv`(sendbuf, recvbuf) | Nonblocking Neighbor All to All Vector.
  `Ineighbor_alltoallw`(sendbuf, recvbuf) | Nonblocking Neighbor All to All General.
  `Neighbor_allgather`(sendbuf, recvbuf) | Neighbor Gather to All.
  `Neighbor_allgather_init`(sendbuf, recvbuf[, info]) | Persistent Neighbor Gather to All.
  `Neighbor_allgatherv`(sendbuf, recvbuf) | Neighbor Gather to All Vector.
  `Neighbor_allgatherv_init`(sendbuf, recvbuf[, ...]) | Persistent Neighbor Gather to All Vector.
  `Neighbor_alltoall`(sendbuf, recvbuf) | Neighbor All to All.
  `Neighbor_alltoall_init`(sendbuf, recvbuf[, info]) | Persistent Neighbor All to All.
  `Neighbor_alltoallv`(sendbuf, recvbuf) | Neighbor All to All Vector.
  `Neighbor_alltoallv_init`(sendbuf, recvbuf[, info]) | Persistent Neighbor All to All Vector.
  `Neighbor_alltoallw`(sendbuf, recvbuf) | Neighbor All to All General.
  `Neighbor_alltoallw_init`(sendbuf, recvbuf[, info]) | Persistent Neighbor All to All General.
  `neighbor_allgather`(sendobj) | Neighbor Gather to All.
  `neighbor_alltoall`(sendobj) | Neighbor All to All.

  Attributes Summary

  `degrees` | Number of incoming and outgoing neighbors.
  `indegree` | Number of incoming neighbors.
  `inedges` | Incoming neighbors.
  `inoutedges` | Incoming and outgoing neighbors.
  `outdegree` | Number of outgoing neighbors.
  `outedges` | Outgoing neighbors.

  Methods Documentation

  Ineighbor_allgather(sendbuf, recvbuf)

    Nonblocking Neighbor Gather to All.

    Parameters:

      - sendbuf (BufSpec)

      - recvbuf (BufSpecB)

    Return type:

      Request

  Ineighbor_allgatherv(sendbuf, recvbuf)

    Nonblocking Neighbor Gather to All Vector.

    Parameters:

      - sendbuf (BufSpec)

      - recvbuf (BufSpecV)

    Return type:

      Request

  Ineighbor_alltoall(sendbuf, recvbuf)

    Nonblocking Neighbor All to All.

    Parameters:

      - sendbuf (BufSpecB)

      - recvbuf (BufSpecB)

    Return type:

      Request

  Ineighbor_alltoallv(sendbuf, recvbuf)

    Nonblocking Neighbor All to All Vector.

    Parameters:

      - sendbuf (BufSpecV)

      - recvbuf (BufSpecV)

    Return type:

      Request

  Ineighbor_alltoallw(sendbuf, recvbuf)

    Nonblocking Neighbor All to All General.

    Parameters:

      - sendbuf (BufSpecW)

      - recvbuf (BufSpecW)

    Return type:

      Request

  Neighbor_allgather(sendbuf, recvbuf)

    Neighbor Gather to All.

    Parameters:

      - sendbuf (BufSpec)

      - recvbuf (BufSpecB)

    Return type:

      None

  Neighbor_allgather_init(sendbuf, recvbuf, info=INFO_NULL)

    Persistent Neighbor Gather to All.

    Parameters:

      - sendbuf (BufSpec)

      - recvbuf (BufSpecB)

      - info (Info)

    Return type:

      Prequest

  Neighbor_allgatherv(sendbuf, recvbuf)

    Neighbor Gather to All Vector.

    Parameters:

      - sendbuf (BufSpec)

      - recvbuf (BufSpecV)

    Return type:

      None

  Neighbor_allgatherv_init(sendbuf, recvbuf, info=INFO_NULL)

    Persistent Neighbor Gather to All Vector.

    Parameters:

      - sendbuf (BufSpec)

      - recvbuf (BufSpecV)

      - info (Info)

    Return type:

      Prequest

  Neighbor_alltoall(sendbuf, recvbuf)

    Neighbor All to All.

    Parameters:

      - sendbuf (BufSpecB)

      - recvbuf (BufSpecB)

    Return type:

      None

  Neighbor_alltoall_init(sendbuf, recvbuf, info=INFO_NULL)

    Persistent Neighbor All to All.

    Parameters:

      - sendbuf (BufSpecB)

      - recvbuf (BufSpecB)

      - info (Info)

    Return type:

      Prequest

  Neighbor_alltoallv(sendbuf, recvbuf)

    Neighbor All to All Vector.

    Parameters:

      - sendbuf (BufSpecV)

      - recvbuf (BufSpecV)

    Return type:

      None

  Neighbor_alltoallv_init(sendbuf, recvbuf, info=INFO_NULL)

    Persistent Neighbor All to All Vector.

    Parameters:

      - sendbuf (BufSpecV)

      - recvbuf (BufSpecV)

      - info (Info)

    Return type:

      Prequest

  Neighbor_alltoallw(sendbuf, recvbuf)

    Neighbor All to All General.

    Parameters:

      - sendbuf (BufSpecW)

      - recvbuf (BufSpecW)

    Return type:

      None

  Neighbor_alltoallw_init(sendbuf, recvbuf, info=INFO_NULL)

    Persistent Neighbor All to All General.

    Parameters:

      - sendbuf (BufSpecW)

      - recvbuf (BufSpecW)

      - info (Info)

    Return type:

      Prequest

  neighbor_allgather(sendobj)

    Neighbor Gather to All.

    Parameters:

      sendobj (Any)

    Return type:

      list[Any]

  neighbor_alltoall(sendobj)

    Neighbor All to All.

    Parameters:

      sendobj (list[Any])

    Return type:

      list[Any]

  Attributes Documentation

  degrees

    Number of incoming and outgoing neighbors.

  indegree

    Number of incoming neighbors.

  inedges

    Incoming neighbors.

  inoutedges

    Incoming and outgoing neighbors.

  outdegree

    Number of outgoing neighbors.

  outedges

    Outgoing neighbors.